Index: /BAORadio/libindi/libindi/libs/indibase/inditelescope.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/inditelescope.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/inditelescope.cpp	(revision 697)
@@ -46,4 +46,5 @@
     MovementWESP = new ISwitchVectorProperty;
     ConfigSV = new ISwitchVectorProperty;
+    ScopeParametersNP = new INumberVectorProperty;
 
 }
@@ -60,46 +61,51 @@
     delete MovementWESP;
     delete ConfigSV;
+    delete ScopeParametersNP;
 }
 
 bool INDI::Telescope::initProperties()
 {
-    DefaultDriver::initProperties();
+    DefaultDevice::initProperties();
 
     IUFillNumber(&EqN[0],"RA","RA (hh:mm:ss)","%010.6m",0,24,0,0);
     IUFillNumber(&EqN[1],"DEC","DEC (dd:mm:ss)","%010.6m",-90,90,0,0);
-    IUFillNumberVector(EqNV,EqN,2,deviceName(),"EQUATORIAL_EOD_COORD","Eq. Coordinates",MAIN_CONTROL_TAB,IP_RO,60,IPS_IDLE);
+    IUFillNumberVector(EqNV,EqN,2,getDeviceName(),"EQUATORIAL_EOD_COORD","Eq. Coordinates",MAIN_CONTROL_TAB,IP_RO,60,IPS_IDLE);
 
     IUFillNumber(&EqReqN[0],"RA","RA (hh:mm:ss)","%010.6m",0,24,0,0);
     IUFillNumber(&EqReqN[1],"DEC","DEC (dd:mm:ss)","%010.6m",-90,90,0,0);
-    IUFillNumberVector(EqReqNV,EqReqN,2,deviceName(),"EQUATORIAL_EOD_COORD_REQUEST","GOTO",MAIN_CONTROL_TAB,IP_WO,60,IPS_IDLE);
+    IUFillNumberVector(EqReqNV,EqReqN,2,getDeviceName(),"EQUATORIAL_EOD_COORD_REQUEST","GOTO",MAIN_CONTROL_TAB,IP_WO,60,IPS_IDLE);
 
     IUFillNumber(&LocationN[0],"LAT","Lat (dd:mm:ss)","%010.6m",-90,90,0,0.0);
     IUFillNumber(&LocationN[1],"LONG","Lon (dd:mm:ss)","%010.6m",-180,180,0,0.0 );
-    IUFillNumberVector(LocationNV,LocationN,2,deviceName(),"GEOGRAPHIC_COORD","Scope Location",SITE_TAB,IP_RW,60,IPS_OK);
+    IUFillNumberVector(LocationNV,LocationN,2,getDeviceName(),"GEOGRAPHIC_COORD","Scope Location",SITE_TAB,IP_RW,60,IPS_OK);
 
     IUFillSwitch(&CoordS[0],"TRACK","Track",ISS_OFF);
     IUFillSwitch(&CoordS[1],"SLEW","Slew",ISS_OFF);
     IUFillSwitch(&CoordS[2],"SYNC","Sync",ISS_OFF);
-    IUFillSwitchVector(CoordSV,CoordS,3,deviceName(),"ON_COORD_SET","On Set",MAIN_CONTROL_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+    IUFillSwitchVector(CoordSV,CoordS,3,getDeviceName(),"ON_COORD_SET","On Set",MAIN_CONTROL_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
 
     IUFillSwitch(&ConfigS[0], "CONFIG_LOAD", "Load", ISS_OFF);
     IUFillSwitch(&ConfigS[1], "CONFIG_SAVE", "Save", ISS_OFF);
     IUFillSwitch(&ConfigS[2], "CONFIG_DEFAULT", "Default", ISS_OFF);
-    IUFillSwitchVector(ConfigSV, ConfigS, 3, deviceName(), "CONFIG_PROCESS", "Configuration", "Options", IP_RW, ISR_1OFMANY, 60, IPS_IDLE);
+    IUFillSwitchVector(ConfigSV, ConfigS, 3, getDeviceName(), "CONFIG_PROCESS", "Configuration", "Options", IP_RW, ISR_1OFMANY, 60, IPS_IDLE);
 
 
     IUFillSwitch(&ParkS[0],"PARK","Park",ISS_OFF);
-    IUFillSwitchVector(ParkSV,ParkS,1,deviceName(),"TELESCOPE_PARK","Park",MAIN_CONTROL_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+    IUFillSwitchVector(ParkSV,ParkS,1,getDeviceName(),"TELESCOPE_PARK","Park",MAIN_CONTROL_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
 
     IUFillText(&PortT[0],"PORT","Port","/dev/ttyUSB0");
-    IUFillTextVector(PortTV,PortT,1,deviceName(),"DEVICE_PORT","Ports",OPTIONS_TAB,IP_RW,60,IPS_IDLE);
+    IUFillTextVector(PortTV,PortT,1,getDeviceName(),"DEVICE_PORT","Ports",OPTIONS_TAB,IP_RW,60,IPS_IDLE);
 
     IUFillSwitch(&MovementNSS[MOTION_NORTH], "MOTION_NORTH", "North", ISS_OFF);
     IUFillSwitch(&MovementNSS[MOTION_SOUTH], "MOTION_SOUTH", "South", ISS_OFF);
-    IUFillSwitchVector(MovementNSSP, MovementNSS, 2, deviceName(),"TELESCOPE_MOTION_NS", "North/South", MOTION_TAB, IP_RW, ISR_1OFMANY, 60, IPS_IDLE);
+    IUFillSwitchVector(MovementNSSP, MovementNSS, 2, getDeviceName(),"TELESCOPE_MOTION_NS", "North/South", MOTION_TAB, IP_RW, ISR_1OFMANY, 60, IPS_IDLE);
 
     IUFillSwitch(&MovementWES[MOTION_WEST], "MOTION_WEST", "West", ISS_OFF);
     IUFillSwitch(&MovementWES[MOTION_EAST], "MOTION_EAST", "East", ISS_OFF);
-    IUFillSwitchVector(MovementWESP, MovementWES, 2, deviceName(),"TELESCOPE_MOTION_WE", "West/East", MOTION_TAB, IP_RW, ISR_1OFMANY, 60, IPS_IDLE);
+    IUFillSwitchVector(MovementWESP, MovementWES, 2, getDeviceName(),"TELESCOPE_MOTION_WE", "West/East", MOTION_TAB, IP_RW, ISR_1OFMANY, 60, IPS_IDLE);
+
+    IUFillNumber(&ScopeParametersN[0],"TELESCOPE_APERTURE","Aperture (mm)","%g",50,4000,0,0.0);
+    IUFillNumber(&ScopeParametersN[1],"TELESCOPE_FOCAL_LENGTH","Focal Length (mm)","%g",100,10000,0,0.0 );
+    IUFillNumberVector(ScopeParametersNP,ScopeParametersN,2,getDeviceName(),"TELESCOPE_PARAMETERS","Scope Properties",OPTIONS_TAB,IP_RW,60,IPS_OK);
 
     TrackState=SCOPE_PARKED;
@@ -111,5 +117,5 @@
     //  First we let our parent populate
     //IDLog("INDI::Telescope::ISGetProperties %s\n",dev);
-    DefaultDriver::ISGetProperties(dev);
+    DefaultDevice::ISGetProperties(dev);
 
     //  We may need the port set before we can connect
@@ -128,4 +134,5 @@
         defineSwitch(MovementWESP);
 		defineSwitch(ConfigSV);
+        defineNumber(ScopeParametersNP);
 
     }
@@ -136,4 +143,5 @@
 {
     defineText(PortTV);
+
     if(isConnected())
     {
@@ -146,8 +154,9 @@
         defineNumber(LocationNV);
         defineSwitch(ParkSV);
-
-    } else
-    {
-        //IDLog("INDI::Telescope deleting properties\n");
+        defineNumber(ScopeParametersNP);
+
+    }
+    else
+    {
         deleteProperty(CoordSV->name);
         deleteProperty(EqNV->name);
@@ -157,7 +166,8 @@
         deleteProperty(LocationNV->name);
         deleteProperty(ParkSV->name);
-
-        //initProperties();
-    }
+        deleteProperty(ScopeParametersNP->name);
+
+    }
+
 	defineSwitch(ConfigSV);
 
@@ -217,5 +227,5 @@
 {
     //  if we get here, our mount doesn't support sync
-    IDMessage(deviceName(),"Mount does not support Sync");
+    IDMessage(getDeviceName(),"Mount does not support Sync");
     return false;
 }
@@ -223,5 +233,5 @@
 bool INDI::Telescope::MoveNS(TelescopeMotionNS dir)
 {
-    IDMessage(deviceName(),"Mount does not support North/South motion");
+    IDMessage(getDeviceName(),"Mount does not support North/South motion");
     IUResetSwitch(MovementNSSP);
     MovementNSSP->s = IPS_IDLE;
@@ -232,5 +242,5 @@
 bool INDI::Telescope::MoveWE(TelescopeMotionWE dir)
 {
-    IDMessage(deviceName(),"Mount does not support West/East motion");
+    IDMessage(getDeviceName(),"Mount does not support West/East motion");
     IUResetSwitch(MovementWESP);
     MovementWESP->s = IPS_IDLE;
@@ -247,5 +257,5 @@
     //IDLog("INDI::Telescope got %d new text items name %s\n",n,name);
     //  first check if it's for our device
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         //  This is for our device
@@ -275,9 +285,9 @@
             //  We processed this one, so, tell the world we did it
             return true;
-        }
-
-    }
-
-    return DefaultDriver::ISNewText(dev,name,texts,names,n);
+        }    
+
+    }
+
+    return DefaultDevice::ISNewText(dev,name,texts,names,n);
 }
 
@@ -289,5 +299,5 @@
     //  first check if it's for our device
     //IDLog("INDI::Telescope::ISNewNumber %s\n",name);
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         if(strcmp(name,"EQUATORIAL_EOD_COORD_REQUEST")==0)
@@ -348,9 +358,20 @@
             IDSetNumber(LocationNV,NULL);
         }
-    }
-
-
-
-    return DefaultDriver::ISNewNumber(dev,name,values,names,n);
+
+        if(strcmp(name,"TELESCOPE_PARAMETERS")==0)
+        {
+            ScopeParametersNP->s = IPS_OK;
+
+            IUUpdateNumber(ScopeParametersNP,values,names,n);
+            IDSetNumber(ScopeParametersNP,NULL);
+
+            return true;
+        }
+
+    }
+
+
+
+    return DefaultDevice::ISNewNumber(dev,name,values,names,n);
 }
 
@@ -365,5 +386,5 @@
     //}
 
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         //  This one is for us
@@ -420,5 +441,5 @@
 
     //  Nobody has claimed this, so, ignore it
-    return DefaultDriver::ISNewSwitch(dev,name,states,names,n);
+    return DefaultDevice::ISNewSwitch(dev,name,states,names,n);
 }
 
@@ -466,5 +487,5 @@
         //if (isDebug())
             IDLog("Failed to connect o port %s. Error: %s", port, errorMsg);
-        IDMessage(deviceName(), "Failed to connect to port %s. Error: %s", port, errorMsg);
+        IDMessage(getDeviceName(), "Failed to connect to port %s. Error: %s", port, errorMsg);
 
         return false;
@@ -481,5 +502,5 @@
     {
         //  We got a valid scope status read
-        IDMessage(deviceName(),"Telescope is online.");
+        IDMessage(getDeviceName(),"Telescope is online.");
         return rc;
     }
@@ -488,5 +509,5 @@
     //  So, we need to close our handle and send error messages
     close(PortFD);
-    //IDMessage(deviceName(),"Didn't find a synscan mount on Serial Port");
+    //IDMessage(getDeviceName(),"Didn't find a synscan mount on Serial Port");
 
     return false;
@@ -502,5 +523,5 @@
 
     close(PortFD);
-    IDMessage(deviceName(),"Telescope is offline.");
+    IDMessage(getDeviceName(),"Telescope is offline.");
 
     return true;
Index: /BAORadio/libindi/libindi/libs/indibase/inditelescope.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/inditelescope.h	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indibase/inditelescope.h	(revision 697)
@@ -20,5 +20,5 @@
 #define INDI_TELESCOPE_H
 
-#include "defaultdriver.h"
+#include "defaultdevice.h"
 
 /**
@@ -42,5 +42,5 @@
 \see TelescopeSimulator and SynScan drivers for examples of implementations of INDI::Telescope.
 */
-class INDI::Telescope : public INDI::DefaultDriver
+class INDI::Telescope : public INDI::DefaultDevice
 {
     private:
@@ -173,4 +173,7 @@
         ISwitchVectorProperty *MovementWESP;
 
+        INumber ScopeParametersN[2];
+        INumberVectorProperty *ScopeParametersNP;
+
 
 };
Index: /BAORadio/libindi/libindi/libs/indicom.c
===================================================================
--- /BAORadio/libindi/libindi/libs/indicom.c	(revision 696)
+++ /BAORadio/libindi/libindi/libs/indicom.c	(revision 697)
@@ -1151,4 +1151,15 @@
 }
 
+/* Find index of the ON member of an ISwitchVectorProperty */
+int IUFindOnSwitchIndex(const ISwitchVectorProperty *svp)
+{
+        int i;
+
+        for (i = 0; i < svp->nsp; i++)
+            if (svp->sp[i].s == ISS_ON)
+                return i;
+        return -1;
+}
+
 /* Set all switches to off */
 void
Index: /BAORadio/libindi/libindi/libs/lilxml.c
===================================================================
--- /BAORadio/libindi/libindi/libs/lilxml.c	(revision 696)
+++ /BAORadio/libindi/libindi/libs/lilxml.c	(revision 697)
@@ -15,5 +15,5 @@
     You should have received a copy of the GNU Lesser General Public
     License along with this library; if not, write to the Free Software
-    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 
 #endif
Index: /BAORadio/libindi/libindi/libs/webcam/v4l2_base.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/webcam/v4l2_base.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/libs/webcam/v4l2_base.cpp	(revision 697)
@@ -218,5 +218,5 @@
 
 		if (-1 == xioctl (fd, VIDIOC_QBUF, &buf))
-			return errno_exit ("VIDIOC_QBUF", errmsg);
+            return errno_exit ("ReadFrame IO_METHOD_MMAP: VIDIOC_QBUF", errmsg);
 
 		break;
@@ -253,5 +253,5 @@
 
 		if (-1 == xioctl (fd, VIDIOC_QBUF, &buf))
-			errno_exit ("VIDIOC_QBUF", errmsg);
+            errno_exit ("ReadFrame IO_METHOD_USERPTR: VIDIOC_QBUF", errmsg);
 
 		break;
@@ -303,5 +303,6 @@
 
 	case IO_METHOD_MMAP:
-		for (i = 0; i < n_buffers; ++i) {
+        for (i = 0; i < n_buffers; ++i)
+        {
             		struct v4l2_buffer buf;
 
@@ -313,8 +314,8 @@
 
         		if (-1 == xioctl (fd, VIDIOC_QBUF, &buf))
-                    		return errno_exit ("VIDIOC_QBUF", errmsg);
+                            return errno_exit ("StartCapturing IO_METHOD_MMAP: VIDIOC_QBUF", errmsg);
 
 		}
-		
+
 		type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
 
@@ -340,5 +341,5 @@
 
         		if (-1 == xioctl (fd, VIDIOC_QBUF, &buf))
-                    		return errno_exit ("VIDIOC_QBUF", errmsg);
+                            return errno_exit ("StartCapturing IO_METHOD_USERPTR: VIDIOC_QBUF", errmsg);
 		}
 
